using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;

using System.Runtime.InteropServices.ComTypes;
using System.IO;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {

        // lots of definitions from http://www.pinvoke.net  
        // plus some modifications as outlined in the article
        //
        // The code that uses these definitions starts at the 
        // Button click event handler lower down.
        //
        [Flags]
        public enum STGM : int
        {
            DIRECT = 0x00000000,
            TRANSACTED = 0x00010000,
            SIMPLE = 0x08000000,
            READ = 0x00000000,
            WRITE = 0x00000001,
            READWRITE = 0x00000002,
            SHARE_DENY_NONE = 0x00000040,
            SHARE_DENY_READ = 0x00000030,
            SHARE_DENY_WRITE = 0x00000020,
            SHARE_EXCLUSIVE = 0x00000010,
            PRIORITY = 0x00040000,
            DELETEONRELEASE = 0x04000000,
            NOSCRATCH = 0x00100000,
            CREATE = 0x00001000,
            CONVERT = 0x00020000,
            FAILIFTHERE = 0x00000000,
            NOSNAPSHOT = 0x00200000,
            DIRECT_SWMR = 0x00400000,
        }

        enum STGTY : int
        {
            STGTY_STORAGE = 1,
            STGTY_STREAM = 2,
            STGTY_LOCKBYTES = 3,
            STGTY_PROPERTY = 4
        };

        enum STREAM_SEEK : int
        {
            STREAM_SEEK_SET = 0,
            STREAM_SEEK_CUR = 1,
            STREAM_SEEK_END = 2
        };
        [ComImport]
        [Guid("0000000d-0000-0000-C000-000000000046")]
        [InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
        public interface IEnumSTATSTG
        {
            // The user needs to allocate an STATSTG array whose size is celt.
            [PreserveSig]
            uint
            Next(
            uint celt,
            [MarshalAs(UnmanagedType.LPArray), Out]
   System.Runtime.InteropServices.ComTypes.STATSTG[] rgelt,
            out uint pceltFetched
            );

            void Skip(uint celt);

            void Reset();

            [return: MarshalAs(UnmanagedType.Interface)]
            IEnumSTATSTG Clone();
        }



        [ComImport]
        [Guid("0000000b-0000-0000-C000-000000000046")]
        [InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
        interface IStorage
        {
            void CreateStream(
                /* [string][in] */ string pwcsName,
                /* [in] */ uint grfMode,
                /* [in] */ uint reserved1,
                /* [in] */ uint reserved2,
                /* [out] */ out IStream ppstm);

            void OpenStream(
                /* [string][in] */ string pwcsName,
                /* [unique][in] */ IntPtr reserved1,
                /* [in] */ uint grfMode,
                /* [in] */ uint reserved2,
                /* [out] */ out IStream ppstm);

            void CreateStorage(
                /* [string][in] */ string pwcsName,
                /* [in] */ uint grfMode,
                /* [in] */ uint reserved1,
                /* [in] */ uint reserved2,
                /* [out] */ out IStorage ppstg);

            void OpenStorage(
                /* [string][unique][in] */ string pwcsName,
                /* [unique][in] */ IStorage pstgPriority,
                /* [in] */ uint grfMode,
                /* [unique][in] */ IntPtr snbExclude,
                /* [in] */ uint reserved,
                /* [out] */ out IStorage ppstg);

            void CopyTo(
                /* [in] */ uint ciidExclude,
                /* [size_is][unique][in] */ Guid rgiidExclude,
                /* [unique][in] */ IntPtr snbExclude,
                /* [unique][in] */ IStorage pstgDest);

            void MoveElementTo(
                /* [string][in] */ string pwcsName,
                /* [unique][in] */ IStorage pstgDest,
                /* [string][in] */ string pwcsNewName,
                /* [in] */ uint grfFlags);

            void Commit(
                /* [in] */ uint grfCommitFlags);

            void Revert();

            void EnumElements(
                /* [in] */ uint reserved1,
                /* [size_is][unique][in] */ IntPtr reserved2,
                /* [in] */ uint reserved3,
                /* [out] */ out IEnumSTATSTG ppenum);

            void DestroyElement(
                /* [string][in] */ string pwcsName);

            void RenameElement(
                /* [string][in] */ string pwcsOldName,
                /* [string][in] */ string pwcsNewName);

            void SetElementTimes(
                /* [string][unique][in] */ string pwcsName,
                /* [unique][in] */ System.Runtime.InteropServices.ComTypes.FILETIME pctime,
                /* [unique][in] */ System.Runtime.InteropServices.ComTypes.FILETIME patime,
                /* [unique][in] */ System.Runtime.InteropServices.ComTypes.FILETIME pmtime);

            void SetClass(
                /* [in] */ Guid clsid);

            void SetStateBits(
                /* [in] */ uint grfStateBits,
                /* [in] */ uint grfMask);

            void Stat(
                /* [out] */ out System.Runtime.InteropServices.ComTypes.STATSTG pstatstg,
                /* [in] */ uint grfStatFlag);

        }


        public struct CatalogHeader
        {
            public short num1;
            public short num2;
            public int thumbCount;
            public int thumbWidth;
            public int thumbHeight;
        }


        public struct CatalogItem
        {
            public int num1;
            public int itemID;
            public DateTime Modified;
            public string filename;
            public short num2;
        }

        [DllImport("ole32.dll")]
        static extern int StgIsStorageFile(
            [MarshalAs(UnmanagedType.LPWStr)]
            string pwcsName);

        [DllImport("ole32.dll")]
        static extern int StgOpenStorage(
            [MarshalAs(UnmanagedType.LPWStr)] string pwcsName
            , IStorage pstgPriority
            , STGM grfMode                // Access Method (uint)
            , IntPtr snbExclude            // Must be NULL
            , uint reserved                // Reserved
            , out IStorage ppstgOpen);    // Returned Storage


        //End of definitions


        public Form1()
        {
            InitializeComponent();
        }
        //
        // Start of example code
        //
        unsafe private void button1_Click(object sender, EventArgs e)
        {

            //Is this a structured storage file.
            string file = @"C:\Documents and Settings\mike.james\My Documents\My Pictures\Purple flowers\Thumbs.db";
            int result = StgIsStorageFile(file);

            //Open the storage file - assumed to be Thumbs.db 
            IStorage Is;
            result = StgOpenStorage(file, null, STGM.READWRITE | STGM.SHARE_EXCLUSIVE, IntPtr.Zero, 0, out Is);

            //Get enumerator
            IEnumSTATSTG SSenum;
            Is.EnumElements(0, IntPtr.Zero, 0, out SSenum);

            System.Runtime.InteropServices.ComTypes.STATSTG[] SSstruct = new System.Runtime.InteropServices.ComTypes.STATSTG[1];
            uint NumReturned;
            do
            {
                SSenum.Next(1, SSstruct, out NumReturned);
                if (NumReturned != 0)
                {
                    textBox1.Text = textBox1.Text + SSstruct[0].pwcsName + " " +
                    SSstruct[0].type.ToString() + Environment.NewLine;
                }
            } while (NumReturned > 0);


            //Open Catalog
            IStream CatStream;
            Is.OpenStream("Catalog", IntPtr.Zero, (uint)(STGM.READWRITE | STGM.SHARE_EXCLUSIVE), 0, out CatStream);

            // Read Catalog
            byte[] buf = new byte[1000];
            uint count;

            // Read Catalog Header
            CatalogHeader CH = new CatalogHeader();
            CatStream.Read(buf, Marshal.SizeOf(CH), new IntPtr(&count));

            BinaryReader head = new BinaryReader(new MemoryStream(buf));
            CH.num1 = head.ReadInt16();
            CH.num2 = head.ReadInt16();
            CH.thumbCount = head.ReadInt32();
            CH.thumbWidth = head.ReadInt32();
            CH.thumbHeight = head.ReadInt32();
            head.Close();

            //Read Catalog item
            CatalogItem CI = new CatalogItem();
            //Read numeric
            CatStream.Read(buf, 16, new IntPtr(&count));
            CI.num1 = BitConverter.ToInt32(buf, 0);
            CI.itemID = BitConverter.ToInt32(buf, 4);
            CI.Modified = DateTime.FromFileTime(BitConverter.ToInt64(buf, 8));
            //Read string

            StringBuilder temp = new StringBuilder(50);
            do
            {
                CatStream.Read(buf, 2, new IntPtr(&count));
                temp.Append(BitConverter.ToChar(buf, 0));
            } while (buf[0] != 0 || buf[1] != 0);
            temp.Length = temp.Length - 1;
            CI.filename = temp.ToString();
            CatStream.Read(buf, 2, new IntPtr(&count));
            CI.num2 = BitConverter.ToInt16(buf, 0);


            //Read and Write JPEG


            IStream ThumbStream;
            Is.OpenStream("1", IntPtr.Zero, (uint)(STGM.READWRITE | STGM.SHARE_EXCLUSIVE), 0, out ThumbStream);

            byte[] bits = new byte[1000];

            BinaryWriter JPEGfile =
                new BinaryWriter(File.Open("1.jpg", FileMode.Create));

            ThumbStream.Read(bits, 12, new IntPtr(&count));

            do
            {
                ThumbStream.Read(bits, 1000, new IntPtr(&count));
                JPEGfile.Write(bits, 0, (int)count);
            } while (count > 0);
            JPEGfile.Close();

            //Read the thumbnail into a bitmap
            uint position;
            ThumbStream.Seek(12, (int)STREAM_SEEK.STREAM_SEEK_SET, new IntPtr(&position));
            System.Runtime.InteropServices.ComTypes.STATSTG fileinfo;
            ThumbStream.Stat(out fileinfo, 0);
            byte[] BitmapData = new byte[fileinfo.cbSize - 12];
            ThumbStream.Read(BitmapData, BitmapData.Length, new IntPtr(&count));
            MemoryStream BitmapStream = new MemoryStream(BitmapData);
            Bitmap Jmap = new Bitmap(BitmapStream);

            pictureBox1.Image = Jmap;



        }



    }
}